Foreman - Bug #28931

If seeding fails, Passenger refuses to start
02/05/2020 10:48 AM - Ewoud Kohl van Wijngaarden

Status: Closed
Priority: Normal
Assignee: Tomer Brisker
Category: DB migrations
Target version: 2.0.0
Difficulty: Fixed in Releases: 2.0.0
Triaged: No Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/7459
Description

When running the installer, | got the following error

/Stage[main] /Foreman_proxy::Register/Foreman_smartproxy[centos7-foreman-nightly.wisse.example.com
]: Could not evaluate: Proxy centos7-foreman-nightly.wisse.example.com cannot be retrieved: unknow
n error (response 500)

After looking for the error in /var/log/foreman/production.log, | couldn't find anything. A closer look showed me the following in
/var/log/httpd/error_log:

[ 2020-02-05 10:39:03.8030 21530/7£0770143700 Pool2/Implementation.cpp:287 ]: Could not spawn proc
ess for application /usr/share/foreman: An error occured while starting up the preloader.
Error ID: 9lebcb548
Error details saved to: /tmp/passenger—error-vJ3j47.html
Message from application: Unable to update template Kickstart default PXEGrub: This template is
locked. Please clone it to a new template to customize. (RuntimeError)
/usr/share/foreman/lib/seed_helper.rb:129:in " import_raw_template'
/usr/share/foreman/lib/seed_helper.rb:138:in "block in import_templates'
/usr/share/foreman/lib/seed_helper.rb:137:in “each'
/usr/share/foreman/lib/seed_helper.rb:137:in " import_templates'
/usr/share/foreman/db/seeds.d/070-provisioning_templates.rb:9:in “block in <top (required)>'
/opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.9.0/1ib/audited/auditor.rb:376:in ‘withou
t_auditing'
/usr/share/foreman/db/seeds.d/070-provisioning_templates.rb:2:in "“<top (required)>'
/opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-5.2.1/1ib/active_support/dependencies
.rb:281:in " load'
/opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-5.2.1/1ib/active_support/dependencies
.rb:281:in “block in load'
/opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-5.2.1/1lib/active_support/dependencies
.rb:253:1in "~ load_dependency'
/opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-5.2.1/1ib/active_support/dependencies
.rb:281:in "~ load'
/usr/share/foreman/app/services/foreman_seeder.rb:39:in “block (2 levels) in execute'
/usr/share/foreman/app/models/concerns/foreman/thread_session.rb:108:in "“as'
/usr/share/foreman/app/models/concerns/foreman/thread_session.rb:114:in "as_anonymous_admin'
/usr/share/foreman/app/services/foreman_seeder.rb:38:in "block in execute'
/usr/share/foreman/app/services/foreman_seeder.rb:32:in ‘each'
/usr/share/foreman/app/services/foreman_seeder.rb:32:in "“execute'
/usr/share/foreman/config/initializers/seeds.rb:8:in “block (2 levels) in <top (required)>'
/opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-5.2.1/1ib/active_support/lazy_load_ho
oks.rb:69:in "block in execute_hook'
/opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-5.2.1/1ib/active_support/lazy_load_ho
oks.rb:62:in “with_execution_control'
/opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-5.2.1/1lib/active_support/lazy_load_ho
oks.rb:67:in “execute_hook'

05/12/2024 1/3




/opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-5.2.1/1ib/active_support/lazy_load_ho
oks.rb:52:in “block in run_load_hooks'

/opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-5.2.1/1ib/active_support/lazy_load_ho
oks.rb:51:in “each'

/opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-5.2.1/1lib/active_support/lazy_load_ho
oks.rb:51:in “run_load_hooks'

/opt/theforeman/tfm/root/usr/share/gems/gems/railties-5.2.1/1ib/rails/application/finisher.rb:75
:in "block in <module:Finisher>'

/opt/theforeman/tfm/root/usr/share/gems/gems/railties-5.2.1/1lib/rails/initializable.rb:32:in “in
stance_exec'

/opt/theforeman/tfm/root/usr/share/gems/gems/railties-5.2.1/1lib/rails/initializable.rb:32:in "ru
nV

/opt/theforeman/tfm/root/usr/share/gems/gems/railties-5.2.1/1ib/rails/initializable.rb:61:in “bl
ock in run_initializers'

/opt/rh/rh-ruby25/root/usr/share/ruby/tsort.rb:228:in “block in tsort_each'

/opt/rh/rh-ruby25/root/usr/share/ruby/tsort.rb:350:in ‘block (2 levels) in each_strongly_connect
ed_component'

/opt/rh/rh-ruby25/root/usr/share/ruby/tsort.rb:431:in ‘each_strongly_connected_component_from'

/opt/rh/rh-ruby25/root/usr/share/ruby/tsort.rb:349:in “block in each_strongly_connected_componen
tV

/opt/rh/rh-ruby25/root/usr/share/ruby/tsort.rb:347:in ‘each’

/opt/rh/rh-ruby25/root/usr/share/ruby/tsort.rb:347:in ‘call’

/opt/rh/rh-ruby25/root/usr/share/ruby/tsort.rb:347:in ‘each_strongly_connected_component'

/opt/rh/rh-ruby25/root/usr/share/ruby/tsort.rb:226:in "tsort_each'

/opt/rh/rh-ruby25/root/usr/share/ruby/tsort.rb:205:in "tsort_each'

/opt/theforeman/tfm/root/usr/share/gems/gems/railties-5.2.1/1ib/rails/initializable.rb:60:in "ru
n_initializers'

/opt/theforeman/tfm/root/usr/share/gems/gems/railties-5.2.1/1ib/rails/application.rb:361:in “ini
tialize!'

/opt/theforeman/tfm/root/usr/share/gems/gems/railties-5.2.1/1lib/rails/railtie.rb:190:in ‘public_
send'

/opt/theforeman/tfm/root/usr/share/gems/gems/railties-5.2.1/1ib/rails/railtie.rb:190:in "method_
missing'

/usr/share/foreman/config/environment.rb:5:in "<top (required)>'

/opt/rh/rh-ruby25/root/usr/share/rubygems/rubygems/core_ext/kernel_require.rb:59:in "“require'

/opt/rh/rh-ruby25/root/usr/share/rubygems/rubygems/core_ext/kernel_require.rb:59:in “require'

config.ru:5:in “block in <main>'

/opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.0.6/1lib/rack/builder.rb:55:in " instance_eval

/opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.0.6/1ib/rack/builder.rb:55:in “initialize'
config.ru:l:in "new'

config.ru:l:in ~<main>"'

/usr/share/passenger/helper-scripts/rack-preloader.rb:112:in “eval'
/usr/share/passenger/helper—-scripts/rack-preloader.rb:112:in “preload_app'
/usr/share/passenger/helper—-scripts/rack-preloader.rb:158:in "~ <module:App>"'
/usr/share/passenger/helper-scripts/rack-preloader.rb:29:in " <module:PhusionPassenger>"'
/usr/share/passenger/helper-scripts/rack-preloader.rb:28:in " <main>'

[ 2020-02-05 10:39:03.8076 21530/7£076dbba700 agents/HelperAgent/RequestHandler.h:2306 ]: [Client
20] Cannot checkout session because a spawning error occurred. The identifier of the error is 9leb
c548. Please see earlier logs for details about the error.

This is a bad user experience because before we rarely if ever got users to look in that file but I'm not sure where we should fix this
(Foreman, Installer, Packaging) so | created the issue in Foreman for now.

Related issues:
Related to Foreman - Feature #28519: Allow storing if db:seed is required wit... Closed

Associated revisions

Revision 3c6b140f - 02/24/2020 01:11 PM - Tomer Brisker
Fixes #28838, #28931 - Safer seeding on initialization

Make sure that migartions have run before attempting to run seeds, to
ensure we don't get into a wierd state of the database if the app is
started before the db has been migrated.

Also, catch and log errors during seeding to prevent passanger from
failing to start if an error occurs.
History

#1 - 02/05/2020 12:21 PM - Eric Helms

Looking at the code, this is the result of a 'raise' with nothing catching it which is fine. However, | could this being more obvious if we add logger
statements before the raise to ensure it appears in the production log?

#2 - 02/05/2020 12:40 PM - Ewoud Kohl van Wijngaarden

Another thing you see is that both dynflow workers get in a restart loop because systemd doesn't figure out it'll never work. On Katello it'll be 3
processes meaning you get 300% CPU usage.

I've now worked around this by changing the seeding script to ignore it, but as a normal user | wouldn't know how to solve this.

#3 - 02/05/2020 12:47 PM - Ewoud Kohl van Wijngaarden
- Related to Feature #28519: Allow storing if db:seed is required within the DB. added

#4 - 02/06/2020 01:23 PM - Tomer Brisker

- Target version set to 2.0.0

#5 - 02/06/2020 01:26 PM - Tomer Brisker
- Category set to Rake tasks

Would it make sense to have a generic catch in the initializer to catch any seed errors that aren't properly handled? maybe show a ui notification with
the message and telling users they need to manually rerun the seed?

#6 - 02/23/2020 01:52 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Tomer Brisker

- Pull request https://github.com/theforeman/foreman/pull/7459 added

#7 - 02/24/2020 01:11 PM - The Foreman Bot
- Fixed in Releases 2.1.0 added

#8 - 02/24/2020 02:01 PM - Tomer Brisker
- Status changed from Ready For Testing to Closed

Applied in changeset 3c6b1406fff0e2104280b6ceec8aa860b5de164.

#9 - 02/26/2020 08:44 AM - Tomer Brisker
- Fixed in Releases 2.0.0 added
- Fixed in Releases deleted (2.1.0)

#10 - 03/05/2020 12:14 PM - Tomer Brisker

- Category changed from Rake tasks to DB migrations
